#!/bin/ksh

rm -rf diag

debug=0

{
    cat cq.initialize.nfd

    print

    while read
    do
	[[ $REPLY == @(quit) ]] && break
	print -r "$REPLY"
    done
} |

{
    cat base-field.bc

    auto-gen.bash

    front-end.bash |&

    while read
    do
	expr=$REPLY

	passes=0

	while true
	do
	    print -p -- ${expr}
	    [[ $debug == 1 ]] && print "SENT <${expr}> to awk" > /dev/tty

	    unset expr

	    while read -pr result
	    do
		[[ $debug == 1 ]] && print "READ FROM AWK: <${result}>" > /dev/tty
		[[ $result == @(EXPR:*)  ]] && expr=${result}
		[[ $result == @(INSTR:*) && $debug == 0 ]] && print -r "${result#INSTR:}"
		[[ $result == @(DONE:*)  ]] && break
	    done

	    [[ -z $expr ]] && break

	    expr=${expr#EXPR:}
            passes=$((passes+1))
            [[ $(( passes % 100 )) -eq 0 ]] && print "AWK PASS: $passes" > /dev/tty
	done

    done
} |

bc -q
